<?php
namespace AustraliaPost\Extensions\Business\API\Wrapper;


class Pay_For_Order_Request {

	/** @var string */
	private $order_id;
	/** @var string */
	private $payment_method;
	/** @var string */
	private $account_number;

	/**
	 * @return string
	 */
	public function getOrderId()
	{
		return $this->order_id;
	}

	/**
	 * @param string $order_id
	 *
	 * @return Pay_For_Order_Request
	 */
	public function setOrderId( $order_id )
	{
		$this->order_id = $order_id;
		return $this;
	}

	/**
	 * @return string
	 */
	public function getPaymentMethod()
	{
		return $this->payment_method;
	}

	/**
	 * @param string $payment_method
	 *
	 * @return Pay_For_Order_Request
	 */
	public function setPaymentMethod( $payment_method )
	{
		$this->payment_method = $payment_method;

		return $this;
	}

	/**
	 * @return string
	 */
	public function getAccountNumber()
	{
		return $this->account_number;
	}

	/**
	 * @param string $account_number
	 *
	 * @return Pay_For_Order_Request
	 */
	public function setAccountNumber( $account_number )
	{
		$this->account_number = $account_number;
		return $this;
	}

	/**
	 * @return array
	 */
	public function getPayload()
	{
		return [
			'order_id' => $this->getOrderId(),
			'payment_method' => $this->getPaymentMethod(),
			'attributes' => ['account-number' => $this->getAccountNumber()]
		];
	}
}
